#ifndef macrolib_ibis_ccvs_abs_INCLUDED
#define macrolib_ibis_ccvs_abs_INCLUDED
#if defined(__GNUC__) && defined(unix)
#  pragma interface "macrolib_ibis_ccvs_abs.hpp"
#endif
#ifndef macrolib_ibis_ccvs_abs_export
#  if defined(_WIN32) && !defined(unix)
#    define macrolib_ibis_ccvs_abs_export __declspec(dllimport)
#  else
#    define macrolib_ibis_ccvs_abs_export
#  endif
#endif
#include "smash_enum.h"
#include "std_standard.hpp"
using namespace STD;
#include "ieee_electrical_systems.hpp"
using namespace IEEE;
namespace MACROLIB
{
class macrolib_ibis_ccvs_abs_export IBIS_CCVS_ABS {
public:
const char *mInstanceName;
static char smGF[1];
char mGF[1];
static STANDARD_REAL smGV0;
const STANDARD_REAL SCALE;
static char smPF[4];
static short smPT[4];
static const char *smAN[4];
char mPF[4];
short mPT[4];
static ELECTRICAL_SYSTEMS_ELECTRICAL *smPV0;
ELECTRICAL_SYSTEMS_ELECTRICAL &P;
static double smPE0;
double mPE0;
T_B3CIDispatcher *P_dispatchers;
static ELECTRICAL_SYSTEMS_ELECTRICAL *smPV1;
ELECTRICAL_SYSTEMS_ELECTRICAL &N;
static double smPE1;
double mPE1;
T_B3CIDispatcher *N_dispatchers;
static ELECTRICAL_SYSTEMS_ELECTRICAL *smPV2;
ELECTRICAL_SYSTEMS_ELECTRICAL &PS;
static double smPE2;
double mPE2;
T_B3CIDispatcher *PS_dispatchers;
static ELECTRICAL_SYSTEMS_ELECTRICAL *smPV3;
ELECTRICAL_SYSTEMS_ELECTRICAL &NS;
static double smPE3;
double mPE3;
T_B3CIDispatcher *NS_dispatchers;
virtual short ElaborateConfiguration(const char *, long) = 0;
public:
IBIS_CCVS_ABS();
virtual ~IBIS_CCVS_ABS();
};
extern "C" macrolib_ibis_ccvs_abs_export const char *MACROLIB_IBIS_CCVS_ABS_GetGenericName(short);
extern "C" macrolib_ibis_ccvs_abs_export const char *MACROLIB_IBIS_CCVS_ABS_GetPortName(short);
extern "C" macrolib_ibis_ccvs_abs_export void MACROLIB_IBIS_CCVS_ABS_InitStaticGenericPort(void);
extern "C" macrolib_ibis_ccvs_abs_export short MACROLIB_IBIS_CCVS_ABS_SetGeneric(const char *, const char *, const char *, const T_B3CIValue *);
extern "C" macrolib_ibis_ccvs_abs_export short MACROLIB_IBIS_CCVS_ABS_SetPort(short inLang, const char *, const char *, const char *, const char *, void *, long, double, short, short);
extern "C" macrolib_ibis_ccvs_abs_export short MACROLIB_IBIS_CCVS_ABS_InstantiateUnmappedPort(const char *);
extern "C" macrolib_ibis_ccvs_abs_export short MACROLIB_IBIS_CCVS_ABS_Elaborate(T_B3CIHandle *, const char *, long, short);
extern "C" macrolib_ibis_ccvs_abs_export short MACROLIB_IBIS_CCVS_ABS_Initialize(T_B3CIHandle, long, double *);
extern "C" macrolib_ibis_ccvs_abs_export short MACROLIB_IBIS_CCVS_ABS_Finalize(T_B3CIHandle);
extern "C" macrolib_ibis_ccvs_abs_export short MACROLIB_IBIS_CCVS_ABS_AmsLink(T_B3CIHandle, long, long **);
extern "C" macrolib_ibis_ccvs_abs_export short MACROLIB_IBIS_CCVS_ABS_AmsBim(T_B3CIHandle, long, TRANS_PARAM_BIM *, long **);
extern "C" macrolib_ibis_ccvs_abs_export short MACROLIB_IBIS_CCVS_ABS_AmsConverge(T_B3CIHandle, long, long **, double *, unsigned char *, ANALYSISTYPE);
}
#endif /* macrolib_ibis_ccvs_abs_INCLUDED */
